#include <windows.h>
#include <stdlib.h>
#include <wtypes.h>
#include <conio.h>
#include <stdio.h>
#include "main.h"

// The following shows the usual functions required to connect and start running the multi-channel-calibration-with-digital-input scan. 
// Functions required to show the data on the console are at the bottom of the page.
// EX_SetScanType, EX_SetMultiChanScanChans, EX_SetDataLogOptions, even EX_SendRate can be excluded by using "M30x_SP.ini" as described in documentation.  
BOOLEAN fSysExit = FALSE;
int __cdecl main()
{
	// DEVELOPER NOTE: You can replace the dot-display below to a progress bar in your GUI type application
	// Only code for model 302 (with it's 8 channels) shown. Model 301 not also shown to keep code to minimum.
	SetCon(); SetConTitle(" Model-302   Sample Application  -  showing scan data averaging techniques"); SetConBlueWhite(); system("cls"); printf("Starting up - please standby .");
	if(!DoInitWithThread()) { SetWhiteRed(); printf("\nStartup failed - any key to exit\n"); getch(); return 0; } 
	while(fWaitInit == TRUE)
	{ SleepEx(500, FALSE); printf(" ."); SleepEx(500, FALSE); printf(" ."); SleepEx(500, FALSE); printf(" ."); SleepEx(500, FALSE); printf(" ."); SleepEx(500, FALSE); printf(" .");   }
	if(!fInitSuccess) { SetWhiteRed();  printf("Device startup failed - any key to exit\n"); getch(); return 0; } 	
	while(true) {
		if((!EX_SetScanType (usDevID, MULTI_CHAN_SCAN)) || (!EX_SetMultiChanScanChans (usDevID, 8)) || (!EX_SetDataLogOptions (usDevID, SCAN_USE_DATA_ARRAY, 0, 0))) break; 
		if(!EX_Run (usDevID)) break; fStartSuccess = TRUE; setMainScreen(); break; 
	} if(!fStartSuccess) { SetWhiteRed(); printf("Scan startup failed - any key to exit\n"); getch(); return 0; } 

	SetConBlueWhite(); SetCurOff(); 
	while(fRunning)
	{
		EX_CheckScanStatus(usDevID, &puiNumScansRemainingInBuff, &pfStillScanning, &puiStatusCode);
		gotoxy(0,4); SetConsoleTextAttribute( hOutCon, 0xa0 ); 
		printf("Scans in buff: % 3u,      Waiting for data: %s,     StillScanning: %s       ", puiNumScansRemainingInBuff, (puiStatusCode & 0x200) == 0x200 ? "YES" : " NO", pfStillScanning > 0 ? "YES" : " NO");
		SetConBlackWhite(); printf("\n");
		//DEVELOPER NOTE: This just keeps the buffer empty if it fills. Only used here because the console writing is slow. 
		//  We do not recommend that you throw away buffered data, but find other ways to keep the buffer emptied. We do it
		//  here only to keep the code complexity to a minimum.
		if(puiNumScansRemainingInBuff > 100) 
		{
			if((int)(puiNumScansRemainingInBuff * 8) > iSizeOfAlloc)
			{
				if(pMemAlloc != NULL) { delete[] pMemAlloc; pMemAlloc = NULL; } 
				pMemAlloc = new INT[puiNumScansRemainingInBuff * 8]; 
			}

			if(pMemAlloc != NULL) 
			{ 
				EX_GetScanDataInt (usDevID, pMemAlloc, puiNumScansRemainingInBuff, FALSE, &puiNumScansReturned, &puiNumScansRemainingInBuff, &pfStillScanning, &puiTotalBuffSize, &puiStatusCode);  
			} 
		}

		if(puiNumScansRemainingInBuff > 0)
		{
			EX_GetScanDataInt (usDevID, piDataBuff, 1, FALSE, &puiNumScansReturned, &puiNumScansRemainingInBuff, &pfStillScanning, &puiTotalBuffSize, &puiStatusCode); 
			showData(0); 
			for(usIndexSub = 0; usIndexSub < 8; usIndexSub++)
			{
				if(!fArrayFirstLoad)	//used here to preload running average array 
				{ 
					for(USHORT i=0; i<AVG_VAL; i++)dblAvgCircularBuff[usIndexSub][i]=piDataBuff[usIndexSub];
					for(i=0; i<AVG_VAL_64; i++) dblAvgCircularBuff_64[usIndexSub][i]=piDataBuff[usIndexSub];
					usBuffHead=AVG_VAL-1; usBuffHead_64=AVG_VAL_64-1; 
				}
				else { dblAvgCircularBuff[usIndexSub][usBuffHead]=iDataBuff[usIndexSub]; dblAvgCircularBuff_64[usIndexSub][usBuffHead_64]=iDataBuff[usIndexSub]; }

				for(USHORT i2=0; i2<AVG_VAL; i2++) iAvgBuff[usIndexSub]=iAvgBuff[usIndexSub] + dblAvgCircularBuff[usIndexSub][usBuffTail + i2];
				for(i2=0; i2<AVG_VAL_64; i2++) iAvgBuff_64[usIndexSub]=iAvgBuff_64[usIndexSub] + dblAvgCircularBuff_64[usIndexSub][usBuffTail_64 + i2];
				
				if(!fArrayFirstLoad)	// preload block average array - not recommended, done here so it shows on screen immediately otherwise it would wait until 32 scans have been retrieved.
				{ for(USHORT i=0; i<AVG_VAL_BLOCK; i++) iAvgBuff_BLOCK[usIndexSub]=iAvgBuff_BLOCK[usIndexSub]+piDataBuff[usIndexSub]; }
				else iAvgBuff_BLOCK[usIndexSub]=iAvgBuff_BLOCK[usIndexSub]+piDataBuff[usIndexSub];
				if(!fArrayFirstLoad)	// preload block average array - not recommended, done here so it shows on screen immediately otherwise it would wait until 32 scans have been retrieved.
				{ for(USHORT i=0; i<AVG_VAL_BLOCK_4; i++) iAvgBuff_BLOCK_4[usIndexSub]=iAvgBuff_BLOCK_4[usIndexSub]+piDataBuff[usIndexSub]; }
				else iAvgBuff_BLOCK_4[usIndexSub]=iAvgBuff_BLOCK_4[usIndexSub]+piDataBuff[usIndexSub];
			}
			if(!fArrayFirstLoad) showData(3); 
				else bAvgCnt_BLOCK_4++; if(bAvgCnt_BLOCK_4 == AVG_VAL_BLOCK_4){ showData(3); bAvgCnt_BLOCK_4=0; } 
			if(!fArrayFirstLoad) showData(4);
				else bAvgCnt_BLOCK++; if(bAvgCnt_BLOCK == AVG_VAL_BLOCK){ showData(4); bAvgCnt_BLOCK=0; } 

			fArrayFirstLoad=TRUE;
			showData(2); showData(1);
			usBuffTail++; if((usBuffTail + AVG_VAL) >= (2*AVG_VAL)) usBuffTail = 0;
			usBuffHead++; if(usBuffHead >= (2*AVG_VAL)) usBuffHead = 0;
			usBuffTail_64++; if((usBuffTail_64 + AVG_VAL_64) >= (2*AVG_VAL_64)) usBuffTail_64 = 0;
			usBuffHead_64++; if(usBuffHead_64 >= (2*AVG_VAL_64)) usBuffHead_64 = 0;
		}
		if(keyChk() || (!pfStillScanning) || (fSysExit)) { EndScan(); break; }
	}   
	if(pMemAlloc != NULL) delete[] pMemAlloc; 
	return 1;
}








//######################################
// Connect/Disconnect thread and related
//######################################
HANDLE	hThread_HANDLE = NULL;
DWORD dwThread_ID;
BOOLEAN fInit=TRUE;
BOOLEAN fWaitEnd = FALSE;
ULONG ThreadFunc(LPVOID pVoid)
{
	if(fInit)
	{
		while(true) 
		{ if(!Init()) break; if(!EX_Connect(&usDevID)) break; fInitSuccess = TRUE; break; }
		if(!EX_SendRate(usDevID, &dblRate)) return FALSE;
		fWaitInit = FALSE; return 0;
	}

	while(true) 
	{
		if(!EX_Stop(usDevID)) break; 
		else { EX_StopComplete(usDevID); fRunning = FALSE; }
		FreeLibrary(hLib301);
		break;
	}
	fWaitEnd = FALSE;
	return 0;
}

BOOLEAN DoInitWithThread(void)
{
	hThread_HANDLE = CreateThread(NULL, 0, ThreadFunc, NULL, CREATE_SUSPENDED, &dwThread_ID);
	if(!hThread_HANDLE) return FALSE;
	ResumeThread(hThread_HANDLE);
	return TRUE;
}

BOOLEAN Init()
{  
 	hLib301 = LoadLibrary ("LL_USB2k.dll"); if(!hLib301) return FALSE;
	EX_Connect = (P_DLL_EX_CONNECT)GetProcAddress(hLib301, "EX_Connect");
	if(!EX_Connect) return FALSE;
	EX_SendRate = (P_DLL_EX_SEND_RATE)GetProcAddress(hLib301, "EX_SendRate");
	if(!EX_SendRate) return FALSE;
	EX_SetScanType =  (P_DLL_EX_SET_SCAN_TYPE)GetProcAddress(hLib301, "EX_SetScanType");
	if(!EX_SetScanType) return FALSE;
	EX_SetMultiChanScanChans =  (P_DLL_EX_SET_MULTI_CHAN_SCAN_CHANS)GetProcAddress(hLib301, "EX_SetMultiChanScanChans");
	if(!EX_SetMultiChanScanChans) return FALSE;
	EX_SetDataLogOptions =  (P_DLL_EX_SET_DATA_LOG_OPTIONS)GetProcAddress(hLib301, "EX_SetDataLogOptions");
	if(!EX_SetDataLogOptions) return FALSE;
	EX_Run =  (P_DLL_EX_RUN)GetProcAddress(hLib301, "EX_Run");
	if(!EX_Run) return FALSE;
	EX_CheckScanStatus = (P_DLL_EX_CHECK_SCAN_STATUS)GetProcAddress(hLib301, "EX_CheckScanStatus");
	if(!EX_CheckScanStatus) return FALSE;
	EX_GetScanDataInt =  (P_DLL_EX_GET_SCAN_DATA_INT)GetProcAddress(hLib301, "EX_GetScanDataInt");
	if(!EX_GetScanDataInt) return FALSE;
	EX_Stop =  (P_DLL_EX_STOP)GetProcAddress(hLib301, "EX_Stop");
	if(!EX_Stop) return FALSE;
	EX_StopComplete =  (P_DLL_EX_STOP_COMPLETE)GetProcAddress(hLib301, "EX_StopComplete");
	if(!EX_StopComplete) return FALSE;
	memset(iDataBuff, 0, sizeof(iDataBuff));
	memset(dblAvgCircularBuff, 0, sizeof(dblAvgCircularBuff));
	memset(iAvgBuff_BLOCK, 0, sizeof(iAvgBuff_BLOCK));
	
    return TRUE;
}




//###############
// Misc functions
//###############
void DoEndScan(void)
{
	fInit = FALSE;
	hThread_HANDLE = CreateThread(NULL, 0, ThreadFunc, NULL, CREATE_SUSPENDED, &dwThread_ID);
	if(!hThread_HANDLE){ fWaitEnd = FALSE; return; }
	ResumeThread(hThread_HANDLE);
	return;
}

BOOLEAN fEndScanBusy = FALSE;
void EndScan(void)
{
	if(fEndScanBusy) return;
	fEndScanBusy = TRUE;
	SetCurOn(); fWaitEnd = TRUE;
	if(!fRunning) return;
	gotoxy(0,24); SetWhiteRed(); printf("Completing scan stop and exiting - wait.");  
	DoEndScan();

	while(fWaitEnd == TRUE)
	{ SleepEx(500, FALSE); printf(" ."); SleepEx(500, FALSE); printf(" ."); SleepEx(500, FALSE); printf(" ."); SleepEx(500, FALSE); printf(" ."); SleepEx(500, FALSE); printf(" .");   }
	fEndScanBusy = FALSE;
}




//#########################
// Screen support functions
//#########################
void setMainScreen(void)
{ system("cls"); SetConBlueWhite(); printf("INITIALIZED.    Rate: %.0lfHz.\nPress 'E' to end scanning and exit", dblRate ); }


void showData(BYTE bAvgIndex)
{
	// DEVELOPER NOTE: Each of the channels below subtract the calibration (offset channel) from the actual voltage
	if(!bAvgIndex)
	{ 
		gotoxy(0,6); SetConsoleTextAttribute( hOutCon, 0xe0 ); printf("No Averaging ------ ");
		double dblOffsetNoAvg = (((piDataBuff[7]) - 8388608) * 0.00000059604645);
		gotoxy(0,7); SetConBlueWhite(); printf("chan 0:    % 2.6lf\n", (((piDataBuff[0]) - 8388608) * 0.00000059604645) - dblOffsetNoAvg);
		printf("chan 1:    % 2.6lf\n", (((piDataBuff[1]) - 8388608)  * 0.00000059604645) - dblOffsetNoAvg);
		printf("chan 2:    % 2.6lf\n", (((piDataBuff[2]) - 8388608)  * 0.00000059604645) - dblOffsetNoAvg);
		printf("chan 3:    % 2.6lf\n", (((piDataBuff[3]) - 8388608)  * 0.00000059604645) - dblOffsetNoAvg);
		printf("chan 4:    % 2.6lf\n", (((piDataBuff[4]) - 8388608)  * 0.00000059604645) - dblOffsetNoAvg);
		printf("chan 5:    % 2.6lf\n", (((piDataBuff[5]) - 8388608)  * 0.00000059604645) - dblOffsetNoAvg);
		printf("offset:    % 2.6lf", dblOffsetNoAvg);
		return;
	}
	if(bAvgIndex == 1)
	{ 
		double dblOffset = ((  ((iAvgBuff_64[7] / (double)usAvg_64)) - 8388608) * 0.00000059604645);
		gotoxy(25,6); SetConsoleTextAttribute( hOutCon, 0xe0 ); printf("Running AVG. --- %u ", usAvg_64);
		gotoxy(25,7); SetConBlueWhite(); printf("chan 0:    % 2.6lf\n", (( ((iAvgBuff_64[0] / (double)usAvg_64))   - 8388608) * 0.00000059604645) - dblOffset);
		gotoxy(25,8); printf("chan 1:    % 2.6lf\n", (( ((iAvgBuff_64[1] / (double)usAvg_64))   - 8388608)  * 0.00000059604645) - dblOffset);
		gotoxy(25,9); printf("chan 2:    % 2.6lf\n", (( ((iAvgBuff_64[2] / (double)usAvg_64))   - 8388608)  * 0.00000059604645) - dblOffset);
		gotoxy(25,10); printf("chan 3:    % 2.6lf\n", (( ((iAvgBuff_64[3] / (double)usAvg_64))   - 8388608)  * 0.00000059604645) - dblOffset);
		gotoxy(25,11); printf("chan 4:    % 2.6lf\n", (( ((iAvgBuff_64[4] / (double)usAvg_64))   - 8388608)  * 0.00000059604645) - dblOffset);
		gotoxy(25,12); printf("chan 5:    % 2.6lf\n", (( ((iAvgBuff_64[5] / (double)usAvg_64))   - 8388608)  * 0.00000059604645) - dblOffset);
		gotoxy(25,13); printf("offset:    % 2.6lf\n", dblOffset);
		memset(iAvgBuff_64, 0, sizeof(iAvgBuff_64));
		return;
	} 
	if(bAvgIndex == 2)
	{ 
		double dblOffset = ((  ((iAvgBuff[7] / (double)usAvg)) - 8388608) * 0.00000059604645);
		gotoxy(50,6); SetConsoleTextAttribute( hOutCon, 0x0e ); printf("Running AVG. --------- %u", usAvg);
		//gotoxy(50,7); SetConBlueWhite(); printf("chan 0:           % 2.6lf\n", (( ((iAvgBuff[0] / (double)usAvg))   - 8388608) * 0.00000059604645) - dblOffset);

		gotoxy(50,7); SetConsoleTextAttribute( hOutCon, 0x80); printf("chan 0:           % 2.6lf\n", (( ((iAvgBuff[0] / (double)usAvg))   - 8388608) * 0.00000059604645) - dblOffset);
		gotoxy(50,8); printf("chan 1:           % 2.6lf\n", (( ((iAvgBuff[1] / (double)usAvg))   - 8388608)  * 0.00000059604645) - dblOffset);
		gotoxy(50,9); printf("chan 2:           % 2.6lf\n", (( ((iAvgBuff[2] / (double)usAvg))   - 8388608)  * 0.00000059604645) - dblOffset);
		gotoxy(50,10); printf("chan 3:           % 2.6lf\n", (( ((iAvgBuff[3] / (double)usAvg))   - 8388608)  * 0.00000059604645) - dblOffset);
		gotoxy(50,11); printf("chan 4:           % 2.6lf\n", (( ((iAvgBuff[4] / (double)usAvg))   - 8388608)  * 0.00000059604645) - dblOffset);
		gotoxy(50,12); printf("chan 5:           % 2.6lf\n", (( ((iAvgBuff[5] / (double)usAvg))   - 8388608)  * 0.00000059604645) - dblOffset);
		gotoxy(50,13); printf("offset:           % 2.6lf\n", dblOffset);
		//gotoxy(50,14); SetConsoleTextAttribute( hOutCon, 0x1f ); printf("( 10 minutes averaged )");
		//gotoxy(50,14); SetConsoleTextAttribute( hOutCon, 0xf1 ); printf("( 10 minutes averaged )");
		gotoxy(50,14); SetConsoleTextAttribute( hOutCon, 0xf1 );   printf(" 10 minutes  worth of scan ");
		gotoxy(50,15); SetConsoleTextAttribute( hOutCon, 0xf1 );   printf(" data being averaged above ");
		memset(iAvgBuff, 0, sizeof(iAvgBuff));
		return;
	}
	if(bAvgIndex == 3)
	{ 
		double dblOffset = ((  ((iAvgBuff_BLOCK_4[7] / (double)usAvg_BLOCK_4)) - 8388608) * 0.00000059604645);
		gotoxy(0,15); SetConsoleTextAttribute( hOutCon, 0xe0 ); printf("Block AVG. ------ %u ", usAvg_BLOCK_4);
		gotoxy(0,16); SetConBlueWhite(); printf("chan 0:    % 2.6lf\n", (( ((iAvgBuff_BLOCK_4[0] / (double)usAvg_BLOCK_4))   - 8388608) * 0.00000059604645) - dblOffset);
		gotoxy(0,17); printf("chan 1:    % 2.6lf\n", (( ((iAvgBuff_BLOCK_4[1] / (double)usAvg_BLOCK_4))   - 8388608)  * 0.00000059604645) - dblOffset);
		gotoxy(0,18); printf("chan 2:    % 2.6lf\n", (( ((iAvgBuff_BLOCK_4[2] / (double)usAvg_BLOCK_4))   - 8388608)  * 0.00000059604645) - dblOffset);
		gotoxy(0,19); printf("chan 3:    % 2.6lf\n", (( ((iAvgBuff_BLOCK_4[3] / (double)usAvg_BLOCK_4))   - 8388608)  * 0.00000059604645) - dblOffset);
		gotoxy(0,20); printf("chan 4:    % 2.6lf\n", (( ((iAvgBuff_BLOCK_4[4] / (double)usAvg_BLOCK_4))   - 8388608)  * 0.00000059604645) - dblOffset);
		gotoxy(0,21); printf("chan 5:    % 2.6lf\n", (( ((iAvgBuff_BLOCK_4[5] / (double)usAvg_BLOCK_4))   - 8388608)  * 0.00000059604645) - dblOffset);
		gotoxy(0,22); printf("offset:    % 2.6lf\n", dblOffset);
		memset(iAvgBuff_BLOCK_4, 0, sizeof(iAvgBuff_BLOCK_4));
		return;
	}
	if(bAvgIndex == 4)
	{ 
		double dblOffset = ((  ((iAvgBuff_BLOCK[7] / (double)usAvg_BLOCK)) - 8388608) * 0.00000059604645);
		gotoxy(25,15); SetConsoleTextAttribute( hOutCon, 0xe0 ); printf("Block AVG. ----- %u ", usAvg_BLOCK);
		gotoxy(25,16); SetConBlueWhite(); printf("chan 0:    % 2.6lf", (( ((iAvgBuff_BLOCK[0] / (double)usAvg_BLOCK))   - 8388608) * 0.00000059604645) - dblOffset);
		gotoxy(25,17); printf("chan 1:    % 2.6lf", (( ((iAvgBuff_BLOCK[1] / (double)usAvg_BLOCK))   - 8388608)  * 0.00000059604645) - dblOffset);
		gotoxy(25,18); printf("chan 2:    % 2.6lf", (( ((iAvgBuff_BLOCK[2] / (double)usAvg_BLOCK))   - 8388608)  * 0.00000059604645) - dblOffset);
		gotoxy(25,19); printf("chan 3:    % 2.6lf", (( ((iAvgBuff_BLOCK[3] / (double)usAvg_BLOCK))   - 8388608)  * 0.00000059604645) - dblOffset);
		gotoxy(25,20); printf("chan 4:    % 2.6lf", (( ((iAvgBuff_BLOCK[4] / (double)usAvg_BLOCK))   - 8388608)  * 0.00000059604645) - dblOffset);
		gotoxy(25,21); printf("chan 5:    % 2.6lf", (( ((iAvgBuff_BLOCK[5] / (double)usAvg_BLOCK))   - 8388608)  * 0.00000059604645) - dblOffset);
		gotoxy(25,22); printf("offset:    % 2.6lf", dblOffset);
		memset(iAvgBuff_BLOCK, 0, sizeof(iAvgBuff_BLOCK));
		return;
	}
}


BOOLEAN keyChk()
{
	if(_kbhit())
	{
		iKeyChar = getch(); cUserInputVal = (char)iKeyChar;
		if((cUserInputVal == 27) || (cUserInputVal == 'E') || (cUserInputVal == 'e'))
		{ EndScan(); cUserInputVal=0; return TRUE; }
		else 
		{ 
			CONSOLE_SCREEN_BUFFER_INFO ci;
			GetConsoleScreenBufferInfo( hOutCon, &ci );
			SetConsoleTextAttribute( hOutCon, 0xe4 );
			gotoxy(0,24); 
			printf("got key: %c  ->   use  'E'  to end scan.", (char)iKeyChar);
			SetConsoleTextAttribute( hOutCon, ci.wAttributes );
		}
	}
	return FALSE;
}

BOOL WINAPI ConHandlerRoutine( DWORD dwCtrlType )
{
	switch(dwCtrlType)
	{
		case CTRL_C_EVENT: case CTRL_BREAK_EVENT: case CTRL_CLOSE_EVENT: case CTRL_LOGOFF_EVENT: case CTRL_SHUTDOWN_EVENT:
			fSysExit = TRUE;
			if(fRunning) while(fRunning) Sleep(200);
			break;
		default: return 0;
	}
	ExitProcess(1);
	return 1;
}


BOOLEAN SetCon(void)
{
	hOutCon = GetStdHandle(STD_OUTPUT_HANDLE);
	if(!hOutCon)
	{ MessageBox(0, "Error writing to console", "-- error", MB_OK); return FALSE; }
	hInCon =  GetStdHandle(STD_INPUT_HANDLE);
	if(!hInCon) { MessageBox(0, "Error reading from console", "-- error", MB_OK); return FALSE; }
	SetCurOn();
	SetConsoleCtrlHandler( ConHandlerRoutine, true );

	return TRUE;
}


void SetCurOn(void)
{ ConsoleCursorInfo.dwSize=1; ConsoleCursorInfo.bVisible = TRUE; SetConsoleCursorInfo(hOutCon, &ConsoleCursorInfo); }
void SetCurOff(void)
{ ConsoleCursorInfo.dwSize=1; ConsoleCursorInfo.bVisible = FALSE; SetConsoleCursorInfo(hOutCon, &ConsoleCursorInfo); }
void SetConBlueWhite(void)
{ SetConsoleTextAttribute( hOutCon, BACKGROUND_BLUE | FOREGROUND_RED | FOREGROUND_GREEN | FOREGROUND_BLUE ); }
void SetWhiteRed(void)
{ SetConsoleTextAttribute( hOutCon, BACKGROUND_RED | BACKGROUND_GREEN | BACKGROUND_BLUE | FOREGROUND_RED); }
void SetConBlackWhite(void)
{ SetConsoleTextAttribute( hOutCon, FOREGROUND_RED | FOREGROUND_GREEN | FOREGROUND_BLUE ); }
void SetConTitle(char* title)
{ SetConsoleTitle( (LPCTSTR)title); }

